package me.unurled.raxen.commands.admin;

import me.unurled.raxen.Raxen;
import me.unurled.raxen.components.entity.other.EntityNamespacedKey;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.command.TabExecutor;
import org.bukkit.entity.Entity;
import org.bukkit.entity.EntityType;
import org.bukkit.entity.Player;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.util.ArrayList;
import java.util.List;

import static me.unurled.raxen.components.entity.other.EntityUtils.setNameSpacedKeys;
import static me.unurled.raxen.utils.Utils.*;

public class SpawnEntity implements TabExecutor {

    private Raxen main;
    private EntityNamespacedKey namespacedKey;

    public SpawnEntity(Raxen main) {
        this.main = main;
        this.namespacedKey = new EntityNamespacedKey(main);
    }

    @Override
    public boolean onCommand(@NotNull CommandSender sender, @NotNull Command command, @NotNull String label, @NotNull String[] args) {
        if (!(sender instanceof Player)) {
            log(colorString("<red>Console can't execute this command!"));
            return false;
        }
        Player player = (Player) sender;
        if (!player.hasPermission("raxen.entityspawn.cmd")) {
            player.sendMessage(noPerms());
            return false;
        }
        //example command : /entityspawn ZOMBIE "&cHello folks" 50 200
        try {
            EntityType types = EntityType.valueOf(args[0]);
            Entity e = player.getWorld().spawnEntity(player.getLocation(), types, false);
            setNameSpacedKeys(e, "<red>Name", 100, 100,0,50,0,100,0,100,0);
            e.customName(colorTextComp(args[1]));
            e.setCustomNameVisible(true);
        } catch (IllegalArgumentException e) {

        }

        return false;
    }

    @Override
    public @Nullable List<String> onTabComplete(@NotNull CommandSender sender, @NotNull Command command, @NotNull String alias, @NotNull String[] args) {
        List<String> list = new ArrayList<>();
        for (EntityType types : EntityType.values()) {
            list.add(types.name());
        }
        return list;
    }
}
