package me.unurled.raxen.components.dungeons.types;

import me.unurled.raxen.components.dungeons.Rank;
import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.World;
import org.bukkit.entity.Entity;
import org.bukkit.entity.EntityType;
import org.bukkit.scheduler.BukkitRunnable;
import org.bukkit.scheduler.BukkitTask;
import org.jetbrains.annotations.Nullable;

import java.util.Random;

import static me.unurled.raxen.utils.Utils.debug;

public class MonsterType {
    public enum type {;

        private Double rate;
        public String ID;
        public Class clazz;

        type(Double rate, String ID, Class clazz) {
            this.rate = rate;
            this.ID = ID;
            this.clazz = clazz;
        }

        public static @Nullable type getTypeById(String ID) {
            for (type type : type.values()) {
                if(type.ID.equals(ID)) {
                    return type;
                }
            }
            return null;
        }

        public Double getRate() {
            return rate;
        }

        public void setRate(Double rate) {
            this.rate = rate;
        }

        public String getID() {
            return ID;
        }

        public void setID(String ID) {
            this.ID = ID;
        }

        public Class getClazz() {
            return clazz;
        }

        public void getClazz(Class clazz) {
            this.clazz = clazz;
        }
    }

    public void genMonster(World world, Rank rank) {
        Double x = 0.0;
        Double y = 100.0;
        Double z = 0.0;
        for (type type : type.values()) {
            type.name();
            Random r = new Random();
            int per = r.nextInt(100);
            if (per >= type.rate) {
                // spawn entity
                debug("Spawning Entity " + type.ID);
                Entity e = world.spawnEntity(new Location(world, x, y, z), EntityType.ARROW);
                // e = ((RaxenEntity) type.getClazz()).createEntity();
                e.setInvulnerable(true);
                BukkitTask task = new BukkitRunnable() {
                    @Override
                    public void run() {
                        Location loc = new Location(e.getWorld(), e.getLocation().getX(), e.getLocation().getY()-1, e.getLocation().getZ());
                        if (loc.getBlock().getType() != Material.AIR) {
                            e.setInvulnerable(false);
                            this.cancel();
                        }
                    }
                }.runTaskTimerAsynchronously(Bukkit.getPluginManager().getPlugin("Raxen"), 0L, 20L);
            }
            x = 5.0 + ( 50.0 - 5.0 ) * r.nextDouble();
            z = 5.0 + ( 50.0 - 5.0 ) * r.nextDouble();
        }
    }
}
