package me.unurled.raxen.components.items.custom.weapon;

import de.tr7zw.nbtapi.NBTItem;
import lombok.Getter;
import me.unurled.raxen.Raxen;
import me.unurled.raxen.components.items.custom.Item;
import net.kyori.adventure.text.Component;
import org.bukkit.Material;
import org.bukkit.enchantments.Enchantment;
import org.bukkit.inventory.ItemFlag;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

import java.util.ArrayList;
import java.util.List;

import static me.unurled.raxen.components.items.NBT.*;
import static me.unurled.raxen.utils.Utils.colorTextComp;

public class Dager implements Item {
    @Getter
    ItemStack dager;

    public void buildItem() {
        dager = new ItemStack(Material.IRON_SWORD);
        ItemMeta itm = dager.getItemMeta();
        itm.displayName(colorTextComp("<aqua>Dager"));
        itm.addEnchant(Enchantment.PROTECTION_ENVIRONMENTAL, 1, false);
        itm.addItemFlags(ItemFlag.HIDE_ATTRIBUTES, ItemFlag.HIDE_ENCHANTS);
        itm.setUnbreakable(true);
        List<Component> lore = new ArrayList<>();
        lore.add(Component.text("hallooo"));
        itm.lore(lore);
        dager.setItemMeta(itm);
        NBTItem nbti = new NBTItem(dager);
        nbti.setString(ID, "DAGER");
        nbti.setInteger(SPEED, 100);
        nbti.setInteger(STRENGTH, 50);
        nbti.setString(CUSTOM_ABILITY, "throwing_dager");
        nbti.setDouble(DROP_RATE, 50.0);
        dager = nbti.getItem();
    }

    /**
     * need Raxen main to be set before calling this method.
     */
    @Override
    public void registerItem(Raxen main) {
        main.getManager().getItemManager().registerItem(dager);
    }
}
