package me.unurled.raxen.manager;

import lombok.Getter;
import me.unurled.raxen.Raxen;
import me.unurled.raxen.manager.entity.*;
import me.unurled.raxen.manager.server.*;
import me.unurled.raxen.utils.libs.Multiverse;

/**
 * Manager class, it enables all features of the plugin.
 * From commands, to Item and worlds, it links all of them together.
 */
public class Manager {

    @Getter
    private WorldManager worldManager;
    @Getter
    private StorageManager storageManager;
    @Getter
    private PlayerManager playerManager;
    @Getter
    private ListenerManager listenerManager;
    @Getter
    private CommandManager commandManager;
    @Getter
    private ItemManager itemManager;
    @Getter
    private ResourcePackManager resourcePackManager;
    @Getter
    private EntityManager entityManager;
    @Getter
    private LootManager lootManager;
    @Getter
    private LibsManager libsManager;
    @Getter private DungeonsManager dungeonsManager;

    @Getter private Multiverse multiverse;

    /**
     * Create an instance of all managers.
     * @param main Raxen
     */
    public void set(Raxen main) {
        libsManager = new LibsManager(main);
        multiverse = new Multiverse();

        worldManager = new WorldManager(main);
        storageManager = new StorageManager(main);

        itemManager = new ItemManager(main);
        playerManager = new PlayerManager(main);
        listenerManager = new ListenerManager(main);
        commandManager = new CommandManager(main);
        resourcePackManager = new ResourcePackManager(main);
        entityManager = new EntityManager(main);
        lootManager = new LootManager(main);
        dungeonsManager = new DungeonsManager(main);
    }
}
